require 'open-uri'

def log_data(tekst)
  log = File.new("#{Time.now.strftime('%Y-%m-%d')}_data.txt",'a')
  log.puts tekst
  log.close
  puts "zapisano do logu danych linie: '#{tekst}'"
rescue Exception => ex
  log_info "error: #{ex.message}"
end

def log_data_minuty(tekst)
  log = File.new("#{Time.now.strftime('%Y-%m-%d')}_data_minuty.txt",'a')
  log.puts tekst
  log.close
  puts "zapisano do logu danych minutowych linie: '#{tekst}'"
rescue Exception => ex
  log_info "error: #{ex.message}"
end

def log_info(tekst)
  tekst = Time.now.strftime('%Y-%m-%d %H:%M:%S,%L ') + tekst 
  log = File.new("#{Time.now.strftime('%Y-%m-%d')}_info.txt",'a')
  log.puts tekst
  log.close
  puts "zapisano do logu bledow linie: '#{tekst}'"
end

def www_read
  http = open('http://192.168.0.38')
  data = http.read
  http.close
  return data
rescue Exception => ex
  log_info "error: #{ex.message}"
end

minuta = Time.now.strftime('%M')
n=0
temperatura_suma = 0

while true do
  odczyt = www_read
  #puts "odczytane dane: #{odczyt}"
  if odczyt != nil then
    odczyt.gsub!('=','[') #podmieniamy znaki = na [
    data = odczyt.split('[') #zamieniemy ciag znakow w tablice uzywajac znaku [ jako znacznika podzialu
    temperatura = data[1].to_f #temperatura to pierwszy element tej tablicy (liczymy od zera)
    temperatura_suma = temperatura_suma + temperatura
    n = n + 1
    log_data("#{Time.now.strftime('%H;%M;%S;%L')};#{temperatura}")
  end
  
  if minuta != Time.now.strftime('%M') and n>0 then
      minuta = Time.now.strftime('%M')
      log_data_minuty("#{Time.now.strftime('%H;%M;')}#{n};#{sprintf("%.5f",temperatura_suma/n)}")
      n= 0
      temperatura_suma = 0
  end
    
  sleep 1
end
